stages:
  - pre
  - build
  - test
  - deploy

## Level 1: Dependency proxy
image: alpine:latest

welcome:
  stage: pre
  script:
    - echo "Welcome to the GitLab Code Challenge @ KubeCon EU 2023"

## Level 2: Image converter, fix the output and tests
### Bonus: SLSA attestation inspection

variables:
  RUNNER_GENERATE_ARTIFACTS_METADATA: 1
  REPO_NAME: gitlab.com/gitlab-code-challenge/kubecon-eu-2023

before_script:
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

.go-tmpl:
  image: golang:1.20-alpine3.16

build:
  extends: .go-tmpl
  stage: build
  script:
    - go build -o tanuki
  artifacts:
    paths:
      - ./tanuki

test:
  extends: .go-tmpl
  stage: test
  script:
    - go test -v

deploy:
  extends: .go-tmpl
  stage: deploy
  variables:
    IMAGE_PATH: "assets/tanuki.png"
    #IMAGE_PATH: "assets/love.png" # Hint: Try enabling this variable as a bonus.
  script:
    - ./tanuki
  artifacts:
    paths:
      - ./tanuki
